#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

double sample( char *chan ) {
  void *handle, *handle2;
  double (*sample)( char *chan );
  char *error;
  double retval = 0;

  handle = dlopen ("./libc1daq.so", RTLD_LAZY | RTLD_GLOBAL);
  if (!handle) {
    fprintf( stderr, "Couldn't open libc1daq: %s\n", dlerror() );
    exit( 1 );
  }

  handle2 = dlopen( "libnidaqmxbase.so", RTLD_LAZY | RTLD_GLOBAL );
  if ( !handle2 ) {
    fprintf( stderr, "Couldn't open libc1daq: %s\n", dlerror() );
    exit( 1 );
  }

  sample = dlsym( handle, "sample" );
  if ((error = dlerror()) != NULL)  {
    fprintf( stderr, "Couldn't find sample() function: %s\n", error );
    exit( 1 );
  }

  retval = (*sample)( chan );

  dlclose( handle );
  dlclose( handle2 );

  return retval;
}

void samplesecond( char *chan, double *data ) {
  void *handle, *handle2;
  void (*samplesecond)( char *chan, double *data );
  char *error;

  handle = dlopen ("./libc1daq.so", RTLD_LAZY | RTLD_GLOBAL);
  if (!handle) {
    fprintf( stderr, "Couldn't open libc1daq: %s\n", dlerror() );
    exit( 1 );
  }

  handle2 = dlopen( "libnidaqmxbase.so", RTLD_LAZY | RTLD_GLOBAL );
  if ( !handle2 ) {
    fprintf( stderr, "Couldn't open libc1daq: %s\n", dlerror() );
    exit( 1 );
  }

  samplesecond = dlsym( handle, "samplesecond" );
  if ((error = dlerror()) != NULL)  {
    fprintf( stderr, "Couldn't find samplesecond() function: %s\n", error );
    exit( 1 );
  }

  (*samplesecond)( chan, data );

  dlclose( handle );
  dlclose( handle2 );
}
